#include "stm32f10x.h"
#include "main.h"
#include <stdio.h>
#include "buzzer_and_led.h"
#include "touch.h"
/*

1.ͬʾ
2.ָʾ
UPԴصַlankexi.cn
*/

#define SOUND_SPEED						10		//ʾٶ
#define LED_SPEED						30		//LEDӻٶ

unsigned char Buzzer_EN = 1;		//ʹ(Ĭ1)
unsigned char Buzzer_type;			//ʾ
unsigned char Last_Buzzer_type;		//ϴʾ
unsigned int Buzzer_count;			//ʱ
unsigned int Buzzer_sound_count;	//Чʱ

//ʾ
#define SOUND_NUM 5  //5Ԫ
// 洢Ƶʡʱռձ
typedef struct {
    unsigned short frequency[SOUND_NUM];
    unsigned short time[SOUND_NUM];
    unsigned short duty_cycle[SOUND_NUM];
} Sound;

// ʼ
Sound sound1 = {
    {16, 280, 200, 600, 20},
    {2, 5, 2, 2, 2},
    {20, 20, 40, 50, 6}
};

Sound sound2 = {
    {16, 280, 200, 600, 20},
    {20, 50, 20, 20, 20},
    {20, 20, 40, 50, 6}
};

Sound sound3 = {
    {80, 800, 200, 800, 20},
    {20, 50, 30, 200, 100},
    {2, 20, 20, 30, 2}
};

Sound sound4 = {
    {120, 80, 200, 120, 80},
    {50, 25, 80, 50, 25},
    {20, 20, 0, 2, 20}
};

Sound sound5 = {
    {20, 800, 200, 800, 80},
    {100, 200, 30, 50, 20},
    {2, 30, 20, 20, 2}
};
// ѡʾ
Sound *current_sound = &sound1;  // Ĭѡsound1

void Buzzer_sound(void){
	if(Buzzer_type != Last_Buzzer_type){Buzzer_count = 0;}
	if(Buzzer_count < SOUND_NUM && Buzzer_EN){
		TIM1->PSC = current_sound->frequency[Buzzer_count];
		TIM1->CCR1 = current_sound->duty_cycle[Buzzer_count];
		Buzzer_sound_count ++;
		if(Buzzer_sound_count > current_sound->time[Buzzer_count] * SOUND_SPEED) {
			Buzzer_count ++;
			Buzzer_sound_count = 0;
			if(Buzzer_count >= SOUND_NUM){
				Buzzer_type = 0;
				TIM1->CCR1 = 0;
			}
		}
	} else{TIM1->CCR1 = 0;}
	Last_Buzzer_type = Buzzer_type;
}

//LEDЧ
void touch_led(void){
	static unsigned int touch_led_count = 0;		//LEDЧʱ
	static unsigned int touch_led_value = 0;		//LED
	if(touch_event.press_down){
		touch_led_count ++;
		if(touch_led_count > LED_SPEED) {
			if(touch_led_value > 60){
				touch_led_value --;
				touch_led_count = 0;
				TIM1->CCR4 = touch_led_value;
			}
			else if(touch_led_value > 10 && touch_size > 1600){
				touch_led_value --;
				touch_led_count = 0;
				TIM1->CCR4 = touch_led_value;
			}
		}
	}
	else {
		touch_led_count ++;
		if(touch_led_count > LED_SPEED && touch_led_value < 99) {
			touch_led_value ++;
			touch_led_count = 0;
			TIM1->CCR4 = touch_led_value;
		} 
	}
}

void select_sound_group(char group) {
    switch(group) {
        case 1:
            current_sound = &sound1;
			Buzzer_type = 1;
            break;
        case 2:
            current_sound = &sound2;
			Buzzer_type = 2;
            break;
        case 3:
            current_sound = &sound3;
			Buzzer_type = 3;
            break;
		case 4:
            current_sound = &sound4;
			Buzzer_type = 4;
            break;
		case 5:
            current_sound = &sound5;
			Buzzer_type = 5;
            break;
        default:
            current_sound = &sound1;  // Ĭʹsound1
			Buzzer_type = 1;
            break;
    }
}


void Buzzer_And_Led_Init(void){
	PWM_GPIO_Configuration();
	TIM1_Configuration();
}

//PWM GPIOʼ
void PWM_GPIO_Configuration(void)
{
	//GPIOAʱ
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA,ENABLE);
	
	GPIO_InitTypeDef GPIO_InitStructure;
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8 | GPIO_Pin_11;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOA,&GPIO_InitStructure);
}

//ƿضʱ
void TIM1_Configuration(void) {
	// ʹܶʱ1ʱ
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_TIM1, ENABLE);

    TIM_TimeBaseInitTypeDef PWM_TIM_TimeBaseStructure;
    // öʱ1
    PWM_TIM_TimeBaseStructure.TIM_Period = 100 - 1; 				//ʱʱ
    PWM_TIM_TimeBaseStructure.TIM_Prescaler = 80;  					//ԤƵ
    PWM_TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1;		//Ƶ
	PWM_TIM_TimeBaseStructure.TIM_RepetitionCounter = 0;			//ظ
    PWM_TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;	//ϼ
    // ʼʱ1
    TIM_TimeBaseInit(TIM1, &PWM_TIM_TimeBaseStructure);
	
	//Ƚϳʼ
	TIM_OCInitTypeDef TIM_OCInitStructure;
	TIM_OCInitStructure.TIM_OCMode = TIM_OCMode_PWM1;				//ȽģʽѡPWMģʽ1
	TIM_OCInitStructure.TIM_OCPolarity = TIM_OCPolarity_High;		//ԣѡΪ
	TIM_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable;	//ʹ
	TIM_OCInitStructure.TIM_Pulse = 0;								//ʼCCRֵ
	TIM_OC1Init(TIM1, &TIM_OCInitStructure);						//TIM1Ƚͨ1
	TIM_OC1PreloadConfig(TIM1, TIM_OCPreload_Enable);				//Ԥװ
	TIM_OC4Init(TIM1, &TIM_OCInitStructure);						//TIM1Ƚͨ1
	TIM_OC4PreloadConfig(TIM1, TIM_OCPreload_Enable);				//Ԥװ
	
    // ʱ1
    TIM_Cmd(TIM1, ENABLE);
	TIM_CtrlPWMOutputs(TIM1, ENABLE);
}

